import numpy as np

m = 0.001
k = 1000

print("\n Would you like to enter parameter values (Y - Procede) ")
if str(input()) == ("y" or "Y"):
    print("\n Woud you like to copy parameters from 1 -> 2 (Y - Procede) ")
    if str(input()) == ("y" or "Y"):
        print("\n Value for R1 and R2 ")
        R1 = int(input())
        R2 = R1
        print("\n Value for Rc1 and Rc2 ")
        Rc1 = int(input())
        Rc2 = Rc1
        print("\n Value for Rb1 and Rb2")
        Rb1 = int(input())
        Rb2 = Rb1
        print("\n Value for Rl")
        Rl = int(input())
        print("\n Value for Re1 and Re2")
        Re1 = int(input())
        Re2 = Re1
    else:
        print("\n Value for R1 ")
        R1 = int(input())
        print("\n Value for R2 ")
        R2 = int(input())
        print("\n Value for Rc1 ")
        Rc1 = int(input())
        print("\n Value for Rc2")
        Rc2 = int(input())
        print("\n Value for Rb1")
        Rb1 = int(input())
        print("\n Value for Rb2")
        Rb2 = int(input())
        print("\n Value for Rl")
        Rl = int(input())
        print("\n Value for Re1")
        Re1 = int(input())
        print("\n Value for Re2")
        Re2 = int(input())
else:
    R1 = 5.1*k
    R2 = R1
    Rc1 = 1.5*k
    Rc2 = Rc1
    Rb1 = 42*k
    Rb2 = Rb1
    Rl = 4.2*k
    Re1 = 270
    Re2 = Re1

#CONSTANTS
vdd = 9
vre = 25*m
vin = 5*m
#Rin = 310
Rin = 50*k


Zin = (Rb2*R2*Rin)/(Rb2*R2+Rb2*Rin+R2*Rin)
Rp2 = (Zin*Rc1)/(Zin+Rc1)
Vb1 = ((R1/(Rb1+R1))*9)
Ve1 = Vb1-(0.7)
Rpb1 = (Ve1/Re1) 
Rp3 = (Rc2*Rl)/(Rc2+Rl)
Vb2 = ((R2/(Rb2+R2))*9)
Ve2 = Vb2 - 0.7
Rpb2 = (Ve2/Re2) 

Ie1 = Ve1 / Re1
Ie2 = Ve2 / Re2

Vc1 = Ie1*Rc1
Vc2 = Ie2*Rc2
Vce1 = vdd - (Ve1+Vc1)
Vce2 = vdd - (Ve2+Vc2)

ic2 = Ie2 + (Vce2/(Rp3+Re2))
ic1 = Ie1 + (Vce1/(Rp2+Re1))

Vcet2 = Vce2 + Ie2*(Rp3+Re2)
Vcet1 = Vce1 + Ie1*(Rp2+Re1)

A1 = Rp2/(Re1+(vre/Rpb1))
A2 = Rp3/(Re2+(vre/Rpb2))

Atotal = A1*A2
vout = Atotal*vin
Isatr = vdd/(Re1+Rc1)
logv = np.log(vout/vin)
dB = 20 * logv

print("\n Input Impedance of Preamp")
print("\n Zin is "+str(Zin)+"\n")

print("\n BJT Current Values")
print("\n Ie1 is "+str(Ie1)+" and Ie2 is "+str(Ie2)+"\n")

print("\n Node Voltages of the BJTs")
print("\n Vb1 is "+str(Vb1)+" and Vb2 is "+str(Vb2))
print("\n Ve1 is "+str(Ve1)+" and Ve2 is "+str(Ve2))
print("\n Vc1 is "+str(Vc1)+" and Vc2 is "+str(Vc2))
print("\n Vce1 is "+str(Vce1)+" and Vce2 is "+str(Vce2)+"\n")

print("\n BJT Parameters")
print("\n Cutoff V1 is "+str(Vcet1)+" and Isat1 is "+str(ic1))
print("\n Cutoff V2 is "+str(Vcet2)+" and Isat2 is "+str(ic2)+"\n")

print("\n Gain of the stages")
print("\n A1 is "+str(A1))
print("\n A2 is "+str(A2)+"\n")

print("\n Total Gain and Output Voltage")
print("\n Atotal is "+str(Atotal))
print("\n Saturation Current "+str(Isatr))
print("\n Voltage input is "+str(vin)+" and Voltage out is "+str(vout))
print("\n dB of gain is "+str(dB)+"\n")
